<?php
/*
Plugin Name: WP-EmbeddedCode
Plugin URI: http://www.delphiarea.com/products/wordpress-plugins/wp-embeddedcode/
Description: Enables you to embed Style, Script, and PHP codes in your posts
Version: 0.1
Author: Kambiz R. Khojasteh
Author URI: kambiz@delphiarea.com
*/

$embedded_code_unique_id = md5(uniqid(rand()));
$embedded_code_stock = array();

add_filter('the_content', 'embedded_code_before', 0);
add_filter('the_content', 'embedded_code_after', 100);

function embedded_code_before($content) {
	return preg_replace_callback('@\[(style|script|php)\b(.*?)(?:(\/))?\](?:(.+?)\[\/\1\])?@s', 'embedded_code_before_callback', $content);
}

function embedded_code_before_callback($m) {
	global $embedded_code_unique_id, $embedded_code_stock;
	$i = count($embedded_code_stock) + 1;
	$embedded_code_stock[$i]['tag'] = $m[1];
	$embedded_code_stock[$i]['atts'] = shortcode_parse_atts($m[2]);
  $embedded_code_stock[$i]['content'] = isset($m[4]) ? trim($m[4]) : '';
  return "<!-- $embedded_code_unique_id-$i -->";
}

function embedded_code_after($content) {
	global $embedded_code_unique_id;
	return preg_replace_callback("@<!-- $embedded_code_unique_id-([0-9]+) -->@", 'embedded_code_after_callback', $content);
}

function embedded_code_after_callback($m) {
	global $embedded_code_stock;
	extract($embedded_code_stock[$m[1]], EXTR_SKIP);
	switch ($tag) {
		case 'style':
			if (!is_feed()) {
				$atts = shortcode_atts(array('type' => 'text/css', 'media' => 'all'), $atts);
				extract($atts, EXTR_SKIP);
				if ($content)
					return "<style type=\"$type\" media=\"$media\">\n<!--\n$content\n-->\n</style>";
			}
			break;
		case 'script':
			if (!is_feed()) {
				$atts = shortcode_atts(array('type' => 'text/javascript'), $atts);
				extract($atts, EXTR_SKIP);
				if ($content)
					return "<script type=\"$type\">\n<!--\n$content\n-->\n</script>";
			}
			break;
		case 'php':
			if ($content) {
				eval($content);
				$output = ob_get_contents();
				ob_end_clean();
				return $output;
			}
			break;
	}
	return '';
}

?>
